"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _cleanCss = _interopRequireDefault(require("clean-css"));

var _loaderUtils = require("loader-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getCleanCssOptions({
  query,
  options
}) {
  if (query && Object.keys(query).length > 0) {
    return query;
  }

  const legacyOptionsSyntax = options && (options.cleancss || options["clean-css"] || options.CleanCSS);
  return legacyOptionsSyntax || {};
}

function cleanCssLoader(css, map) {
  const callback = this.async();
  const cleanCssOptions = getCleanCssOptions({
    query: (0, _loaderUtils.getOptions)(this),
    options: this.options ? this.options.module : false
  });
  return new _cleanCss.default(cleanCssOptions).minify(css, map, (err, minified) => {
    if (err) {
      return callback(err[0]);
    }

    if (!cleanCssOptions.skipWarn && Array.isArray(minified.warnings)) {
      minified.warnings.forEach(warning => {
        this.emitWarning(warning.toString());
      });
    }

    return callback(null, minified.styles, minified.sourceMap);
  });
}

var _default = cleanCssLoader;
exports.default = _default;
module.exports = exports.default;